#include <bits/stdc++.h>
using namespace std;

string readLine() {
    string s;
    assert(getline(cin, s));
    return s;
}

void assertEOF() {
    string s;
    assert(!getline(cin, s));
}

void assertNumber(string s) {
    assert(s[0] == '+' || s[0] == '-' || isdigit(s[0]));
    for (int i = 1; i < s.size(); i++) assert(isdigit(s[i]));
    if (!isdigit(s[0])) s.erase(0);
    assert(s.size() != 0);
    assert(s.size() == 1 || s[0] != '0');
}

vector<string> readTokens(char delim) {
    string s = readLine();
    if (s.empty()) return {};

    vector<string> tokens(1);
    for (char c: s) {
        if (c == delim) tokens.push_back("");
        else tokens.back().push_back(c);
    }
    return tokens;
}

vector<long long> longlongTokens(char delim) {
    vector<string> a = readTokens(delim);
    vector<long long> b;
    for (string& s: a) {
        b.push_back(stoll(s));
    }
    return b;
}

vector<string> stringTokens(char delim) {
    vector<string> a = readTokens(delim);
    vector<string> b;
    for (string& s: a) {
        b.push_back(s);
    }
    return b;
}

int ok[1000000];

int main() {
    vector<string> line1 = stringTokens(' ');
    assert(line1.size() == 1);
    string s = line1[0];
    assert(s.size() > 0);
    for (char c: s) {
        assert(islower(c));
    }

    vector<long long> line2 = longlongTokens(' ');
    assert(line2.size() == 1);
    int n = line2[0];
    assert(1 <= n && n <= 1e6);

    vector<string> v;
    for (int i = 0; i < n; i++) {
        vector<string> line = stringTokens(' ');
        assert(line.size() == 1);
        assert(line[0].size() > 0);
        for (char c: line[0]) assert(islower(c));
        v.push_back(line[0]);
    }

    vector<long long> line3 = longlongTokens(' ');
    assert(line3.size() == 1);
    int k = line3[0];
    assert(1 <= k && k <= 1e9);

    assertEOF();

    for (int i = 0; i < n; i++) {
        string t = v[i];
        if (s == t) ok[i] = true;
    }
    k%=n;

    int ans = INT_MAX;
    for (int i = 0; i < n; i++) {
        if (!ok[i]) continue;

        int current = (i-k+n)%n;
        ans = min(ans, current);
    }
    cout << ans << endl;

    return 0;
}
